/******************************************************************************
	M[`
	optimization level=s
******************************************************************************/
#include <math.h>
#include <p30f2012.h>
#include <dsp.h>
#include "spdiv.h"		// ̒ɃRpCe؂芷XCb`

fractional hpfout, lpfout, audioin;		// o͊֐access()ƂƂ肷ϐ
#define NUMSAMP		1	// x̊֐ĂяoŌvZTv


/******************************************************************************
	`lfBoC_(FIRtB^)pϐƏ֐
******************************************************************************/
// `lfBoC_HPF̌W
#if DIVIDER5K
	#define	NUMCOEFFS	25
	const fractional firTaps[ NUMCOEFFS ] = {	// const:auto_psv
		-160, -216, -181, 56, 474, 889, 987, 449, -870, -2813, 
		-4907, -6525, 25634, -6525, -4907, -2813, -870, 449, 
		987, 889, 474, 56, -181, -216, -160
	};
	//	DSPLink Remez Algorithm HPF̃p[^
	//	fs = 44100Hz, fc1 = 2465Hz, fc2 = 7000Hz, N = 25
	//	attenuate = -50dB, ripple factor = 0.1, 16bits, format=Dec
#else
	#define	NUMCOEFFS	117
	const fractional firTaps[ NUMCOEFFS ] = {
		-67, -28, -33, -38, -42, -46, -49, -50, -51, -50, -47, -42, -35, -26, 
		-14, -1, 14, 31, 50, 71, 92, 113, 135, 155, 175, 191, 205, 215, 221, 
		222, 216, 204, 185, 159, 125, 83, 33, -23, -89, -161, -240, -325, 
		-415, -508, -605, -703, -801, -898, -993, -1083, -1169, -1248, -1319, 
		-1381, -1434, -1475, -1505, -1524, 31237, -1524, -1505, -1475, -1434, 
		-1381, -1319, -1248, -1169, -1083, -993, -898, -801, -703, -605, -508, 
		-415, -325, -240, -161, -89, -23, 33, 83, 125, 159, 185, 204, 216, 222,
		221, 215, 205, 191, 175, 155, 135, 113, 92, 71, 50, 31, 14, -1, -14, 
		-26, -35, -42, -47, -50, -51, -50, -49, -46, -42, -38, -33, -28, -67
	};
	//	DSPLink Remez Algorithm HPF̃p[^
	//	fs = 44100Hz, fc1 = 570Hz, fc2 = 1500Hz, N = 117
	//	attenuate = -50dB, ripple factor = 0.05, 16bits, format=Dec
#endif
#define FIRPAG		0		// firTaps̔zuꂽPSVy[WԍB
FIRStruct hpf[2];			// FIRtB^Ǘp\́BLR 2ch
fractional _YBSS(2) delaybuf[NUMCOEFFS],delaybuf2[NUMCOEFFS];
													// Y2byteACg

void divider_init()
{
	FIRStructInit(&(hpf[0]), NUMCOEFFS, (fractional*)firTaps, FIRPAG, delaybuf);
	FIRDelayInit( &(hpf[0]) );
	FIRStructInit(&(hpf[1]), NUMCOEFFS, (fractional*)firTaps, FIRPAG, delaybuf2);
	FIRDelayInit( &(hpf[1]) );
}


/******************************************************************************
	OCR(IIRtB^)pϐƏ֐
******************************************************************************/
fractional _XDATA(2) GEQCoefs[ 5 * GEQNumSections ] = {	// l̓tbg
//	 b0/2, b1/2, a1/2, b2/2, a2/2
	16384,    0,    0,    0,    0,	// 񎟃tB^1(ݸ100Hz)
	16384,    0,    0,    0,    0,	// 񎟃tB^2( 1kHz)
	16384,    0,    0,    0,    0,	// 񎟃tB^3( 3kHz)
	16384,    0,    0,    0,    0	// 񎟃tB^4(10kHz)
};

fractional _YBSS(2) GEQStates1_ch1[GEQNumSections], GEQStates2_ch1[GEQNumSections];
fractional _YBSS(2) GEQStates1_ch2[GEQNumSections], GEQStates2_ch2[GEQNumSections];

IIRTransposedStruct GraphicEqualizer[2] = {	// LR 2ch
	{
		GEQNumSections-1,
		GEQCoefs,
		COEFFS_IN_DATA,		// WGEQCoefsXf[^ɂ邱ƂwB
		GEQStates1_ch1,		// xobt@
		GEQStates2_ch1,
		0					//final shift. negative indicates shift left,
	},
	{
		GEQNumSections-1,
		GEQCoefs,
		COEFFS_IN_DATA,		// WGEQCoefsXf[^ɂ邱ƂwB
		GEQStates1_ch2,		// xobt@
		GEQStates2_ch2,
		0					//final shift. negative indicates shift left,
	}
};

void GEQ_init()
{
	IIRTransposedInit(&(GraphicEqualizer[0]));	// LR 2ch
	IIRTransposedInit(&(GraphicEqualizer[1]));
}


/******************************************************************************
	RB0̏ԕωʒm荞({\tg̗B̊荞)
******************************************************************************/
extern unsigned daccont[DACCONTNO];	// main()ƋLBD/A䃌WX^
extern MENU_VAL preatt;				// main()ƋL
void _ISR _AltCNInterrupt( void )
{
	static int ch, i;
	fractional dly;
	RED;
	do{
		access(daccont[i]);			// CPLDƒʐM
		if(++i >= DACCONTNO)
			i = 0;
#if SIGAD
		audioin = ADCBUF0;			// 12bitA/Dʎ擾
		ADCON1bits.SAMP = 0;		// 12bitA/DϊJn
#endif
		ch ^= 1;					// L/R`l݂ɏ
		audioin >>= preatt;
#if DIVIDER5K
		IIRTransposed(NUMSAMP, &audioin, &audioin, &(GraphicEqualizer[ch]));
#endif
		FIR(NUMSAMP, &hpfout, &audioin, &(hpf[ch]));
		dly = GetFIRDelayDat(&(hpf[ch]), NUMCOEFFS/2, NUMCOEFFS);
		lpfout = dly - hpfout;		// Z^fBoC_(OaZ͂ĂȂ)
		IFS0bits.CNIF = 0;			// 荞݃tONA
	}while(PORTBbits.RB0);			// ݂RB0ԕωʒm荞ڼ޽
	GREEN;
}


/******************************************************************************
	xf[^擾
	FIRStruct\̂delayNumxf[^ԂB
******************************************************************************/
fractional GetFIRDelayDat( FIRStruct *filter, unsigned delayNum, 
														unsigned NumCoeffs )
{
	fractional *p = filter->delay + delayNum + 1;
	if( p > filter->delayEnd )
		p -= NumCoeffs;
	return *p;
}


/******************************************************************************
	OCRIIRtB^WvZB
	OCR̊egݒlzɓÃAhXgeqŎw肷B
	vZIIRtB^WGEQCoefsɏo͂B
******************************************************************************/
#define fs			44100	// TvOg [Hz]
#define AMAX		1.45	// g̕`萔AB̍őlEŏl
#define AMIN		0.45
#define GEQNO		(GEQNumSections-1)
#define IIRNUMCOF	5	// IIRTransposed b0,b1,a1,b2,a2 5̌W^
void calc_geqcoef( MENU_VAL *geq )
{
	const unsigned frqtbl[GEQNO] = { 1000, 3000, 10000 };
	int f;
	fractional coefbuf[IIRNUMCOF];
	fractional *coef = GEQCoefs + IIRNUMCOF;	// 1ڂͼݸނȂ̂Ŕ΂

	for( f=0; f<GEQNO; f++ ){
		float wo = 2 * PI * frqtbl[f];
		float p = 4.0*fs*fs + wo*wo;
		float q = 2.0 * fs * wo;
		float A = (*geq++ / 18.0 + 0.5) * (AMAX - AMIN)  +  AMIN;
		float B = AMAX + AMIN - A;
		float k0a = 32768 / 2 / (p + q/A);
		
		coefbuf[0] = k0a * (p + q/B);				// b0/2
		coefbuf[1] = k0a * (2.0*wo*wo - 8.0*fs*fs);	// b1/2
		coefbuf[2] = -coefbuf[1];					// a1/2
		coefbuf[3] = k0a * (p - q/B);				// b2/2
		coefbuf[4] = k0a * (q/A - p);				// a2/2
		
//		DIS_INTERRUPT;	// ZԂmemcpyΊ֎~ȂĂɲނ͖ڗȂ
		memcpy( coef, coefbuf, sizeof(coefbuf) );	// 0.4us(opt1)
//		ENA_INTERRUPT;
		coef += IIRNUMCOF;
	}
}


/******************************************************************************
	VFrO^CvIIRtB^WvZB
	ቹparam(-9`+9)ɂđB
	vZIIRtB^WGEQCoefsɏo͂B
******************************************************************************/
#define STEP	1.136463666		// =SQRT(10)^(1/9) 9Xebv10dB
void calc_shelvcoef( MENU_VAL param )
{
	const unsigned shelvingf0 = 200;		// R[i[g [Hz]
	fractional coefbuf[IIRNUMCOF];
	float k0;
	float w1 = 2 * PI * shelvingf0;
	float w0 = w1 * pow( STEP, abs(param) );
	if( param < 0 ){
		w1 = w0;
		w0 = 2 * PI * shelvingf0;
	}
	
	k0 =  32768 / 2 / ( w1 + 2 * fs );
	coefbuf[0] = k0 * ( w0 + 2 * fs );		// b0/2
	coefbuf[1] = k0 * ( w0 - 2 * fs );		// b1/2
	coefbuf[2] = k0 * ( 2 * fs - w1 );		// a1/2
	coefbuf[3] = 0;							// b2/2
	coefbuf[4] = 0;							// a2/2

//	DIS_INTERRUPT;
	memcpy( GEQCoefs, coefbuf, sizeof(coefbuf) );	// 0.4us(opt1)
//	ENA_INTERRUPT;
}
