/******************************************************************************
	dsPICgXs[JfBoC_ƃOCR			'08 Masaji Kasahara
******************************************************************************/
#include <p30f2012.h>
#include <adc12.h>
#include <timer.h>
#include "spdiv.h"		// ̒ɃRpCe؂芷XCb`
#define RERR	0x40	// Xe[^XǂݏoRERR bit

MENU_VAL volume=255, geq[GEQNumSections];
MENU_VAL preatt;		// 荞݃[`ƋL
struct menu_dat menu_dats[] = {
	// type,       str,              *value, max,min,row,column,curpos
	{ INT_MENU,    "255",            &volume,255,  0,  0,   7,    1  },
	{ SELECT_MENU, "  0, -6,-12,-18",&preatt,  0,  0,  1,   7,    0  },
	{ INT_MENU,    "+9",             geq+0 ,   9, -9,  3,   5,    0  },
	{ INT_MENU,    "+9",             geq+1 ,   9, -9,  3,   8,    0  },
	{ INT_MENU,    "+9",             geq+2 ,   9, -9,  3,  11,    0  },
	{ INT_MENU,    "+9",             geq+3 ,   9, -9,  3,  15,    0  }
};

unsigned daccont[DACCONTNO];	// main() - 荞݃[`ԂŋL

int main( void )
{
	int nosig, beforenosig=0;
	SET_CPU_IPL( 7 );	// 荞݋֎~
	Nop();
	divider_init();
	GEQ_init();
	init();
	SET_CPU_IPL( 0 );	// 荞݋
	lcd_init();
	LCD_LOCATE( 0, 0 );	lcd_str( "Volume:000" );	// j[\
	LCD_LOCATE( 1, 0 );	lcd_str( "PreATT:  0dB" );
#if DIVIDER5K
	LCD_LOCATE( 2, 0 );	lcd_str( "GEQ 100 1k 3k 10kHz" );
	LCD_LOCATE( 3, 0 );	lcd_str( "      0  0  0   0" );
#endif
	while(1){
		menu( menu_dats, MENU_NO );			// [U[C^tF[X
		calc_shelvcoef(geq[0]);				// OCR1ڂ̓VFrO^
		calc_geqcoef(geq+1);				// OCR̃tB^WvZ
		nosig = PORTB & RERR;				// CS8416RERRo疳M
		if( nosig != beforenosig ){			// \eςƂLCD
			beforenosig = nosig;
			LCD_LOCATE(0,11);
			if( nosig )	lcd_str( "NO SIGNAL" );
			else		lcd_str( "         " );
		}
		daccont[0] = volume | 0x1000;		// Lch{[
		daccont[1] = volume | 0x1100;		// Rch{[
		daccont[2] = nosig? 0x1203: 0x1200;	// MUTE I[o[TvO64
	}
}

void init( void )
{
	int i;
	BUS_RD = 1;
	BUS_STB = 0;
	TRISB = BUS_IN_TRIS;
	TRISC = 0x0000;	// 1̃rbg͓̓s
	TRISD = 0x0300;
	TRISF = 0x0000;
	_ALTIVT=1;		//AIVTgp
	
	// F^C}T2delay()ŎgpBT1

	// fobOpA/DZbgAbv
	OpenADC12(	ADC_MODULE_ON & ADC_IDLE_CONTINUE & ADC_FORMAT_SIGN_FRACT
					& ADC_CLK_MANUAL		//ϊJn͎蓮
					& ADC_AUTO_SAMPLING_ON	//ϊłɻݸފJn
					& ADC_SAMP_ON,
				ADC_VREF_AVDD_AVSS & ADC_SCAN_OFF & ADC_SAMPLES_PER_INT_1
					& ADC_ALT_BUF_OFF & ADC_ALT_INPUT_OFF,
				ADC_CONV_CLK_SYSTEM & ADC_CONV_CLK_4Tcy,	//50ns * 4
				ENABLE_AN9_ANA,
				0 );
	SetChanADC12( ADC_CH0_POS_SAMPLEA_AN9	//CH0 = AN9
					& ADC_CH0_NEG_SAMPLEA_NVREF );

	// RB0̏ԕωʒm荞ݐݒ
	CNEN1bits.CN2IE = 1;	// RB0̏ԕωĎ
	IFS0bits.CNIF = 0;		// 荞݃tONA
	IPC3bits.CNIP = 4;		// CN荞ݗD揇
	IEC0bits.CNIE = 1;		// CN荞ݗL

	for(i=0; i<30; i++){	// CPLDZbg
		BUS_STB = 0;
		BUS_STB = 1;
	}
}
