/******************************************************************************
	Xs[JfBoC_ CPLDeXgx`t@C

	V~[^FVeritak-Lite Ver.2.05A7
******************************************************************************/
module test_SpDivider;
	reg clk=1, nrst=1, bus_rd, bus_stb;
	wire[7:0] dat_bus;
	reg[7:0] cpuout='hzz;
	wire dir, cclk, clatch, cdata, sdin;
	reg bclk=0, lrck=1, load=0;
	reg [15:0] para_in;
	wire [15:0] para_out;
	wire [7:4] lcd_d;
	wire lcd_rs, lcd_stb, ser_hpf, ser_lpf, done, relay;
	
// I[fBIM
	initial  begin nrst=1; #100 nrst=0; #100 nrst=1;  end
	always bclk=#177 ~bclk;
	always lrck=#(64*177) ~lrck;
	initial begin
		oncerd('hCDF4, 6660);
		oncerd('h7921, 500);
		oncerd('hE9A5, 440);
		oncerd('h287F, 440);
		oncerd('hB558, 500);
		oncerd('h0001, 77);
		oncerd('h0000, 1111);
		#5555;$finish;
	end
	task oncerd;
		input [22:0]audiodat, writedelay;
		begin
			#writedelay;
			para_in = audiodat;
			#50;load=1;#50;load=0;
			@(negedge done);
		end
	endtask
	
	//CDv[fW^osdin
	LeftJustifyOutSlave sout( bclk, lrck, load, para_in, sdin );
	
	// łLeftJustifyIn𓮍`FbN
	LeftJustifyIn sin ( bclk, lrck, ~nrst, done, sdin, para_out );
	
// CPUANZX
	always clk=#25 ~clk;
	initial begin
		bus_rd=1;bus_stb=0; #100 bus_stb=1; #100 bus_stb=0;#100;
		cpurd(50, 'h69, 'hbc, 'hf0, 'hc2, 'h10, 'hff, 'hf0 );
		cpurd(50, 'h00, 'h00, 'h61, 'hff, 'h01, 'hba, 'h61 );
		cpurd(50, 'h91, 'hfe, 'hff, 'h01, 'hac, 'h23, 'hff );
		cpurd(50, 'h00, 'h00, 'hff, 'hff, 'hff, 'hff, 'hbf );
		cpurd(50, 'hf0, 'h00, 'h00, 'hff, 'h0f, 'hf0, 'h00 );
		cpurd(50, 'hec, 'hdb, 'haf, 'h11, 'hab, 'hcd, 'haf );
		cpurd(50, 'hef, 'hf2, 'h07, 'h77, 'h12, 'h23, 'h07 );
	end
	task cpurd;
		input [22:0]writedelay, R0, R1, R2, R3, R4, R5, R6;
		begin
			@(posedge dat_bus[0]);
			#(writedelay*3); bus_rd=0;#writedelay;#writedelay;
			#writedelay; cpuout=R0; #writedelay; bus_stb=1; #writedelay; bus_stb=0;
			#writedelay; cpuout=R1; #writedelay; bus_stb=1; #writedelay; bus_stb=0;
			#writedelay; cpuout=R2; #writedelay; bus_stb=1; #writedelay; bus_stb=0;
			#writedelay; cpuout=R3; #writedelay; bus_stb=1; #writedelay; bus_stb=0;
			#writedelay; cpuout=R4; #writedelay; bus_stb=1; #writedelay; bus_stb=0;
			#writedelay; cpuout=R5; #writedelay; bus_stb=1; #writedelay; bus_stb=0;
			#writedelay; cpuout=R6; #writedelay; bus_stb=1; #writedelay; bus_stb=0;
			#writedelay; 
			cpuout='hzzzz;
			#(writedelay*2);  
			bus_rd=1;
			#writedelay; #writedelay; #writedelay; 
			#writedelay; #writedelay; bus_stb=1; #writedelay; bus_stb=0;
			#writedelay; #writedelay; bus_stb=1; #writedelay; bus_stb=0;
		end
	endtask
	assign dat_bus=cpuout;
	SpDivider top(clk, nrst, bus_rd, bus_stb, dat_bus, dir, relay, 0, lcd_d, lcd_rs,
		lcd_stb, cclk, clatch, cdata, sdin, lrck, bclk, 0, ser_hpf, ser_lpf );
endmodule
